//  insert header/copyright here
#pragma implementation
#include "find_leaks.h"
#include <fstream.h>
#include <assert.h>
#include "Srcstream.h"

srcstream* srcstream::nullStream = 0;

// Constructor
srcstream::srcstream(ostream &o, unsigned long line=1) 
  : fLineNumber(line), fIndentation(0), ostr(&o)
{
}

srcstream &
srcstream::PushIndent(int n)
{
  fIndentation += n;
  return (*this);
}

srcstream &
srcstream::ToLine(unsigned long line, bool space)
{
  if (line >= ((unsigned long) -100)) { line = 1; }
  if (line < fLineNumber) {
    if (space) 
      (*ostr) << " ";
  } else if (fLineNumber == line) {
    if (space)
      (*ostr) << " ";
  } else {
    for (unsigned long i = fLineNumber; i < line; ++i) {
      (*ostr) << "\n";
    }
    fLineNumber = line;
    for (unsigned i = 0; i < fIndentation; ++i) {
      (*ostr) << " ";
    }
  }
  return (*this);
}

// Goes to line if possible, otherwise doesn't.
srcstream &
srcstream::ToLineF(unsigned long line, bool space)
{
  if (line >= ((unsigned long) -100)) { line = 1; }
  if (line < fLineNumber) {
    if (space)
      (*ostr) << " ";
  } else if (fLineNumber == line) {
    if (space)
      (*ostr) << " ";
  } else {
    for (unsigned long i = fLineNumber; i < line; ++i) {
      (*ostr) << "\n";
    }
    fLineNumber = line;
    for (unsigned i = 0; i < fIndentation; ++i) {
      (*ostr) << " ";
    }
  }
  return (*this);
}

// Goes to (line-before) if possible, but advances at least one line, 
// up to line.
srcstream &
srcstream::ToLineBefore(unsigned long line, unsigned long before, bool space)
{
  if (before>line) { 
    if (space) 
      (*ostr) << " "; 
    return *this; 
  }

  if (line-before > fLineNumber) { return ToLineF(line-before); }
  if (line > fLineNumber)        { return ToLineF(fLineNumber+1); }

  if (space)
    (*ostr) << " ";
  return (*this);

}

// Advance to the next line
srcstream &
srcstream::Next()
{  
  return ToLineF(fLineNumber+1);
}

// Get a stream pointed to /dev/null.
srcstream &
srcstream::GetNullStream()
{
  if (!nullStream) {
    ofstream* devnull = new ofstream;
    devnull->open("/dev/null");
    if (!devnull->is_open()) {
      cerr << ">> Couldn't open /dev/null" << endl;
      assert(0);
    }
    nullStream = new srcstream(*devnull);
  }
  return *nullStream;
}
