
#ifndef _INSTANTIATION_MACROS_H
#define _INSTANTIATION_MACROS_H

// The macros defined in this file are used to instantiate various template 
// types, and thereby make the *Instantiations.C files more readable

#define PAIR_T(x,y) pair< x const , y > 
#define TREE_T(x,y) \
        rb_tree< x, PAIR_T(x,y), select1st< PAIR_T(x,y), x >, less<x > >
#define TREEITER_T(x,y) TREE_T(x,y)::iterator
#define CTREEITER_T(x,y) TREE_T(x,y)::const_iterator
#define MAP_T(x,y) map<x, y, less<x> >
#define MMAP_T(x,y) multimap<x, y, less<x> >

#define STREE_T(x) rb_tree< x, x, ident<x, x>, less<x> >
#define STREEITER_T(x) STREE_T(x)::iterator
#define CSTREEITER_T(x) STREE_T(x)::const_iterator

#define DEQUE_T(x) deque<x>
#define DEQUEITER_T(x) deque<x>::iterator
#define CDEQUEITER_T(x) deque<x>::const_iterator

#define DECL_MAP1(x,y,z) template class MAP_T(x,y); \
                      template class TREE_T(x,z); \
                      template class PAIR_T(x,z); \
                      template bool operator!=(TREEITER_T(x,z) const &, \
                                               TREEITER_T(x,z) const &); \
                      template bool operator!=(CTREEITER_T(x,z) const &, \
                                               CTREEITER_T(x,z) const &); 

#define DECL_MAP_CPTR(x,y) DECL_MAP1(x,const y*, y const *)
#define DECL_MAP(x,y) DECL_MAP1(x,y,y)

#define DECL_MMAP1(x,y,z) template class MMAP_T(x,y); \
                      template class TREE_T(x,z); \
                      template class PAIR_T(x,z); \
                      template bool operator!=(TREEITER_T(x,z) const &, \
                                               TREEITER_T(x,z) const &); \
                      template bool operator!=(CTREEITER_T(x,z) const &, \
                                               CTREEITER_T(x,z) const &); 

#define DECL_MMAP_CPTR(x,y) DECL_MMAP1(x,const y*, y const *)
#define DECL_MMAP(x,y) DECL_MMAP1(x,y,y)


#define DECL_DEQUE(x) template class DEQUE_T(x); \
                      template bool operator!=(DEQUEITER_T(x) const &, \
                                               DEQUEITER_T(x) const &); \
                      template bool operator!=(CDEQUEITER_T(x) const &, \
                                               CDEQUEITER_T(x) const &); 
                      
#define DECL_VECTOR(x) template class vector<x>;

#define DECL_SET(x) template class set<x, less<x> >; \
                    template class STREE_T(x); \
                    template bool operator!=(STREEITER_T(x) const &, \
					     STREEITER_T(x) const &); \
                    template bool operator!=(CSTREEITER_T(x) const &, \
					     CSTREEITER_T(x) const &);

#define DECL_LESS(x) template class less<x>;

#endif
